## ksh 2020.0.0

=== meson_options.txt ===
# We don't use posix_spawn() by default due to a race condition involving
# setting the terminal foreground process group. If you want to risk failures
# due to that scenario build with `meson -Duse-spawn=true`.
#
# See https://github.com/att/ast/issues/468.
option('use-spawn', type : 'boolean', value : false)

# Enable this when running unit tests.
option('unittest', type : 'boolean', value : false)

# This build symbol used to be named SHOPT_TIMEOUT. It was renamed when it
# stopped being used to conditionally compile segments of code. It defines
# the default, and maximum, read timeout value (see the `TMOUT` shell var).
#
# TODO: Use the following definition when we can count on Meson 0.45 being
# available on the platforms we care about. For the moment we're stuck with
# Meson 0.44.
# option('read-timeout', type : 'integer', min : 0, value : 0)
#
option('read-timeout', type : 'string', value : '0')

# This build symbol used to be named SHOPT_AUDITFILE. It was renamed when it
# stopped being used to conditionally compile segments of code. It defines
# the default pathname for recording shell auditable events.
#
option('audit-file', type : 'string', value : '/etc/ksh_audit')

# To disable building api tests, set build-api-tests option to false:
#   meson -Dbuild-api-tests=false
option('build-api-tests', type : 'boolean', value : true)

# To build api tests only, set build-api-tests-only option to true:
#   meson -Dbuild-api-tests-only=true
option('build-api-tests-only', type : 'boolean', value : false)

# This number is used when git is not available
#   meson -Dfallback-version-number='x.y.z'
option('fallback-version-number', type : 'string', value : '2020.0.0')

# To build with support for ASAN (AddressSanitizer:
#   meson -DASAN=true
option('ASAN', type : 'boolean', value : false)

# Enable this in CI environments to cause compiler warnings to be treated
# as errors.
option('warnings-are-errors', type : 'boolean', value : false)

=== .copr/Makefile ===
mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
current_dir := $(notdir $(patsubst %/,%,$(dir $(mkfile_path))))

srpm:
	dnf -y install git-core sed
	$(current_dir)/prep.sh
	rpmbuild -bs -D "dist %{nil}" -D "_sourcedir packaging/fedora" -D "_srcrpmdir $(outdir)" --nodeps packaging/fedora/ksh.spec

=== debian/changelog ===
ksh (2020.0.0-5) unstable; urgency=high

  * Team upload.
  * Remove unused french shcomp manpage: outdated and not in UTF-8
  * Bump Policy (no change)
  * Update several more places with ksh2020 name and references
  * Fix doc-base section
  * Add UMEGAYA file
  * Switch to update-alternatives for binfmt-misc registration
  * Bring back /{,usr/}bin/ksh symlink fix
  * Refresh all patches
  * Add debian/NEWS, documenting why this package was split

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 27 Jan 2020 16:45:42 +0100

ksh (2020.0.0-4) unstable; urgency=high

  * Piuparts issue (Closes: #949764)
  * Separated shcomp to its own alternative
  * Updated man page to reflect new binary name

 -- Anuradha Weeraman <aweeraman@gmail.com>  Fri, 24 Jan 2020 20:05:27 -0500

ksh (2020.0.0-3) unstable; urgency=high

  * Rename binary to ksh2020 to support co-existence with ksh93
  * Use alternative system for ksh, shcomp and rksh
  * Fix for broken restricted shell, issue 1459

 -- Anuradha Weeraman <aweeraman@gmail.com>  Sun, 19 Jan 2020 01:43:52 -0500

ksh (2020.0.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/0008: Cherry-pick upstream security fix.
    (CVE-2019-14868, Closes: #948989)

 -- Boyuan Yang <byang@debian.org>  Wed, 15 Jan 2020 12:17:25 -0500

ksh (2020.0.0-2) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/control: Add vim and ed as <!nocheck> build-dependencies
    (though known to be failing).

  [ Anuradha Weeraman ]
  * Fixed typo in man page, and other documentation/lintian fixes
  * Removed source/lintian-overrides as it is redundant
  * CI configuration for Debian Salsa
  * Lintian override for package-contains-empty-directory
  * Updated the .desktop file, lintian fix
  * Patches for build-time test failures
  * New maintainer (Closes: #924979)

 -- Anuradha Weeraman <aweeraman@gmail.com>  Sat, 19 Oct 2019 19:16:04 -0400

ksh (2020.0.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream stable release (2020.0.0).
  * debian/patches: Drop all backported patches, merged upstream.
  * debian/control:
    + Bump Standards-Version to 4.4.1.
    + Use "Rules-Requires-Root: no".

 -- Boyuan Yang <byang@debian.org>  Thu, 10 Oct 2019 10:15:52 -0400

ksh (2020.0.0~beta1-3) unstable; urgency=medium

  * QA upload.
  * debian/patches:
    + Backport upstream 2020.0.0 branch commits till 2019-09-27.
    + Recover patch to use "ex" instead of "ed" by default for fs
      and hist commands.

 -- Boyuan Yang <byang@debian.org>  Fri, 27 Sep 2019 14:12:18 -0400

ksh (2020.0.0~beta1-2) unstable; urgency=medium

  * QA upload.
  * debian/watch: Minor fixes to the uscan script.
  * debian/source.lintian-overrides: Move to d/s/lintian-overrides.
  * debian/patches: Backport upstream 2020.0.0 branch commits
    till 2019-09-17.

 -- Boyuan Yang <byang@debian.org>  Wed, 25 Sep 2019 11:49:05 -0400

ksh (2020.0.0~beta1-1) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.
  * debian/control: Mark build-dependency netcat-openbsd and
    expect with <!nocheck>.
  * debian/patches: Backport upstream patches in 2020.0.0
    branch.

 -- Boyuan Yang <byang@debian.org>  Tue, 17 Sep 2019 15:32:07 -0400

ksh (2020.0.0~beta1-1~exp1) experimental; urgency=medium

  * QA upload.
  * New upstream beta release (2020.0.0-beta1).
  * debian/control:
    + Add build-dependency netcat-openbsd and expect for tests.
    + Bump Standards-Version to 4.4.0.
  * debian/rules: Add check for DEB_BUILD_OPTIONS in dh_auto_test
    to handle "nocheck" build profile.

 -- Boyuan Yang <byang@debian.org>  Tue, 03 Sep 2019 10:38:17 -0400

=== debian/control ===
Source: ksh
Section: shells
Priority: optional
Maintainer: Anuradha Weeraman <aweeraman@gmail.com>
Homepage: https://github.com/att/ast
Build-Depends:
 debhelper-compat (= 12),
 dh-exec,
 ed <!nocheck>,
 expect <!nocheck>,
 locales-all,
 meson,
 netcat-openbsd <!nocheck>,
 ninja-build,
 procps,
 vim <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian/ksh.git
Vcs-Browser: https://salsa.debian.org/debian/ksh

Package: ksh
Architecture: any
Replaces: ksh93
Depends:
 binfmt-support,
 ${misc:Depends},
 ${shlibs:Depends},
Description: 2020 version of the AT&T Korn Shell
 Ksh is a UNIX command interpreter (shell) that is intended for both
 interactive and shell script use. Its command language is a superset of
 the sh(1) shell language.
 .
 The 1993 version adds a number of new, mostly scripting related,
 features over the 1988 version that is typically distributed with
 commercial UNIX variants. For example, it has lexical scoping, compound
 variables, associative arrays, named references and floating point
 math.
 .
 The shcomp tool can be used to compile ksh scripts into a binary format.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# reproducibility
LC_ALL=C
LANG=C
TZ=/usr/share/zoneinfo/Etc/GMT
export LC_ALL
export LANG
export TZ

# provide a fake HOME directory to solve test fails
HOME=$(CURDIR)/debian/fakehome
export HOME

%:
	dh $@ --no-parallel

override_dh_auto_install:
	dh_auto_install
	# Rename /usr/bin/ksh93 to /usr/bin/ksh2020 to co-exist with ksh93
	# as well as make use of the alternative system
	mv $(CURDIR)/debian/ksh/usr/bin/ksh $(CURDIR)/debian/ksh/usr/bin/ksh2020
	mv $(CURDIR)/debian/ksh/usr/bin/shcomp $(CURDIR)/debian/ksh/usr/bin/shcomp2020
	# Also rename the man pages
	mv $(CURDIR)/debian/ksh/usr/share/man/man1/ksh.1 \
	        $(CURDIR)/debian/ksh/usr/share/man/man1/ksh2020.1

override_dh_installchangelogs:
	# ChangeLog till 93v is provided in src/cmd/ksh93/RELEASE
	dh_installchangelogs -k CHANGELOG.md

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Multiple tests fail, skipping for now
	-dh_auto_test
endif

=== debian/watch ===
version=4
opts="uversionmangle=s/-(?=alpha|beta|devel)/~/,filenamemangle=s%(?:.*?)?(?:ksh)?v?([\da-zA-Z_.-]*)\.tar\.gz%ksh-$1.tar.gz%" \
 https://github.com/att/ast/tags \
 (?:.*?/)?v?(?:ksh)?([\da-zA-Z_.-]*)\.tar\.gz debian uupdate

## ksh 2020.0.0+really93u+20120801

=== src/cmd/INIT/Makefile ===
/*
 * initialization for all packages
 */

ID = ast
SILENT = /* this component builds silent -- this prevents us from using it while building it */

:PACKAGE: license=$(ID)

LICENSE = since=1994,author=gsf

PACKAGEROOT = $(INSTALLROOT:T=F:P=L*:O=n)

hurl :: hurl.sh LICENSE=since=2003,author=gsf

iffe :: iffe.sh LICENSE=since=1994,author=gsf+kpv

mktest :: mktest.sh LICENSE=since=2005,author=gsf

package :: package.sh

regress :: regress.sh LICENSE=since=1995,author=gsf

rt :: rt.sh LICENSE=since=2005,author=gsf

$(PACKAGEROOT)/bin :INSTALLDIR: execrate ignore mamprobe package silent

crossexec :: crossexec.sh

ditto :: ditto.sh LICENSE=since=2001,author=gsf+ek

execrate :: execrate.sh LICENSE=since=2002,author=gsf

filter :: filter.sh

ignore :: ignore.sh

silent :: silent.sh

$(PACKAGEROOT)/lib/package :INSTALLDIR: package.mk CONVERT.mk

$(LIBDIR)/make :INSTALLDIR: package.mk PROBE.mk TEST.mk WWW.mk \
	MSGFUN.mk MSGKEY.mk MAPLIB.mk

:TEST: iffe mamake

cc ld ldd :PACKAGE_INIT: mamake.c proto.c ratz.c release.c

:: RELEASE hosttype.tst p.c hello.c \
	ar.ibm.risc \
	cc.specialize cc.pentium4 \
	ldd.cygwin.i386 \
	cc.darwin.i386 cc.darwin.i386-64 cc.darwin ldd.darwin \
	cc.hp.ia64 cc.hp.pa cc.hp.pa64 ld.hp.pa ldd.hp.pa \
	cc.ibm.risc cc.ibm.risc.gcc ldd.ibm.risc \
	cc.linux.ia64-icc cc.linux.i386-icc cc.linux.i386-64-icc \
	cc.lynxos.i386 cc.lynxos.ppc ldd.lynxos \
	cc.mvs.390 cc.next.i386 cc.next.m68k ldd.mvs.390 \
	cc.osf.alpha \
	cc.sco.i386 \
	cc.sgi.mips2 cc.sgi.mips3 cc.sgi.mips3-o32 cc.sgi.mips4 \
	cc.sgi.mips4-n32 ldd.sgi \
	cc.unix.mc68k

LICENSE : .DONTCARE

if ! CC.HOSTTYPE
	CC.HOSTTYPE := $(_hosttype_|HOSTTYPE)
end

$(BINDIR)/mkdir :INSTALL: mkdir.sh
	if	test ! -x $(<) -a -x /bin/mkdir
	then	mkdir -p 2>/dev/null || :
		if	test -d ./-p
		then	rmdir ./-p
			cp $(*) $(<)
			chmod +x $(<)
		fi
	fi

/*
 * ksh93 function search on PATH
 * ksh93 builtin command library -lcmd
 * ksh93 ld library path search on PATH
 */

$(BINDIR)/.paths :INSTALL: (CC.DIALECT)
	if	test ! -f $(<) -o -w $(<)
	then	N='$("\n")'
		H=$(CC.HOSTTYPE)
		P="$(-mam:??$(.GETCONF LIBPATH:/:/ /G:/,/ : /G:Q)?)"
		b= f= h= l= n= p= u= B= L=
		set : $P
		while	:
		do	while	:
			do	case $1 in
				'')	break 2 ;;
				:)	shift; break ;;
				esac
				shift
			done
			case $# in
			0|1)	break ;;
			esac
			case $L in
			?*)	L="$L|" ;;
			esac
			L="$L$2=*"
			B=$1
		done
		if	test -f $(<)
		then	while	read x
			do	case $x in
				*\$\(\"*)	break # to fix 2012-06-18 edit botch #
						;;
				'#'?*)		case $h in
						'')	h=$x ;;
						esac
						;;
				$L)		l=$x
						;;
				*BUILTIN_LIB=*)	b=$x
						;;
				*FPATH=*)	f=$x
						;;
				*PLUGIN_LIB=*)	p=$x
						;;
				*)		case $u in
						?*)	u=$u$N ;;
						esac
						u=$u$x
						;;
				esac
			done < $(<)
		fi
		ifs=$IFS
		m=
		case $p in
		?*)	b=
			;;
		esac
		case $b in
		?*)	IFS='='
			set $b
			IFS=$ifs
			shift
			p="PLUGIN_LIB=$*"
			case $b in
			[Nn][Oo]*)	p=no$p ;;
			esac
			m=1
			;;
		esac
		case $f in
		'')	f="FPATH=../fun"
			m=1
			;;
		esac
		case $h in
		'')	h='# use { no NO } prefix to permanently disable #' ;;
		esac
		case $l in
		'')	set x x : $P
			l=
			while	:
			do	while	:
				do	case $# in
					0)	break ;;
					esac
					x=$1
					shift
					case $x in
					:)	break ;;
					esac
				done
				case $# in
				0|1)	break
					;;
				2)	l=$2
					;;
				*)	case "$H" in
					$3)	l=$2; break ;;
					esac
					;;
				esac
			done
			case $l in
			'')	if	test -x /lib/dld.sl
				then	l=SHLIB_PATH
				elif	test -x /usr/lib/dyld
				then	l=DYLD_LIBRARY_PATH
				else	case "$H" in
					ibm.*|mvs.*)
						l=LIBPATH
						;;
					sgi.mips3)	
						l=LD_LIBRARYN32_PATH
						;;
					sgi.mips4)	
						l=LD_LIBRARYN64_PATH
						;;
					*)	l=LD_LIBRARY_PATH
						;;
					esac
				fi
				;;
			esac
			case $l in
			?*)	case $B in
				'')	B=lib ;;
				esac
				l="$l=../$B"
				m=1
				;;
			esac
			;;
		esac
		case $p in
		'')	p="PLUGIN_LIB=cmd"
			case '$(CC.DIALECT:N=*EXPORT=[AD]LL*)' in
			'')	p=no$p ;;
			esac
			m=1
			;;
		esac
		case $m in
		1)	case $u in
			?*)	u=$N$u ;;
			esac
			echo "$h$N$p$N$f$N$l$u" > $(<)
			;;
		esac
	fi

/*
 * probe initialization
 */

for T C+probe C+make+probe.lcl C+pp+probe.lcl
	if T == "*.lcl"
		$(T) : .DONTCARE
	end
	$(LIBDIR)/probe/$(T:C,+,/,G) :INSTALL: $(T)
end

$(LIBDIR)/probe/C/mam/probe :INSTALL: mprobe

mprobe :: mprobe.sh

$(LIBDIR)/probe/C/make :INSTALLDIR: probe probe.ini

probe.sh : C+probe make.probe
	cat $(*) > $(<)

probe :: probe.sh

probe.ini : (CC.HOSTTYPE) probe.win32
	t=$(CC.HOSTTYPE)
	ifs=$IFS
	IFS=.
	set x $t
	IFS=$ifs
	t=$2
	set x $(*)
	while	:
	do	shift
		case $# in
		0)	break ;;
		esac
		case $1 in
		*probe.$t)
			break
		esac
	done
	case $1 in
	?*)	cmp -s $1 $(<) || cp $1 $(<) ;;
	*)	: > $(<)
	esac

/*
 * proto initialization
 */

$(INCLUDEDIR)/$(ID) :INSTALLDIR: prototyped.h

prototyped.h : $(BINDIR)/proto
	proto -f /dev/null > h.$(tmp).h
	if	$(CMP) -s h.$(tmp).h $(<)
	then	$(RM) -f h.$(tmp).h
	else	$(MV) h.$(tmp).h $(<)
	fi

/*
 * check if -ldl is required
 * this allows makefiles to use -ldl on all systems
 *
 * NOTE: this works around the sgi botch:
 *	 (1) irix 5.* made -ldl optional but warned
 *	 (2) irix 6.* has no -ldl
 *	 (3) dynamic progs built on irix 5.* and using -ldl fail
 *           at runtime on irix 6.* because -ldl is not there
 */

dl :MAPLIB: dl.c

/*
 * requiring these is a botch
 */

iconv :MAPLIB: iconv.c

w :MAPLIB: w.c w2.c

/*
 * miscellaneous -l* checks
 */

intl :MAPLIB: intl.c

m :MAPLIB: m.c m2.c m3.c m4.c m5.c m6.c

nsl :MAPLIB: nsl.c

/*
 * what was sco smoking
 * almost all of gethost* are in -lnsl except gethostbyname which
 * is in -lsocket which isn't needed to resolve socket() but seems
 * to do the -lnsl job
 */

socket :MAPLIB: socket.c nsl.c

/*
 * more substance abuse
 * gdbm's ndbm "compatibility" doesn't supply <ndbm.h>, instead supplies
 * <gdbm/ndbm.h> which provides K&R prototypes *and* it requires -lgdbm
 * some <ndbm.h> implementations use -lndbm, others -ldbm, still others -lc
 * this is why unix is starting to look like windows
 * this map allows makefiles to use -ldbm on all systems
 *
 * and this just in: sometimes its <gdbm-ndbm.h> and possibly -lgdbm_compat
 *
 * at least the -l* buck stops here
 */

dbm db - gdbm_compat - gdbm - ndbm - dbm :MAPLIB: db.c gdbm.c gdbm1.c gdbm2.c

=== src/lib/libast/Makefile ===
/*
 * ast library
 */

:PACKAGE: ast

LICENSE = since=1985,author=gsf+dgk+kpv

ID = ast

HOSTTYPE == "$(CC.HOSTTYPE)"

CCFLAGS = $(CC.SUFFIX.DEBUG:+$(CC.DEBUG)) $(CC.OPTIMIZE) $(CC.DLL)

IFFEFLAGS = -v -X ast -X std

.SOURCE : aso cdt comp dir disc hash man misc obsolete path port preroot \
		regex sfio stdio string tm uwin vec vmalloc

.SOURCE.h : include comp std cdt vmalloc

CP = $(STDCP|"cp")

PARANOID ==
CONF_LIBPREFIX == "$(CC.PREFIX.DYNAMIC|CC.PREFIX.SHARED)"
CONF_LIBSUFFIX == "$(CC.SUFFIX.DYNAMIC|CC.SUFFIX.SHARED)"
DEBUG ==
__OBSOLETE__ == $("6 months ago":@F=%(%Y0101)T)

HEADERSRC = ast.h ast_dir.h ast_getopt.h ast_std.h \
	ast_namval.h ast_windows.h \
	ccode.h cdt.h cdtlib.h cmdarg.h debug.h dt.h error.h find.h ftw.h \
	ftwalk.h fts.h fs3d.h getopt.h glob.h hash.h hashkey.h hashpart.h \
	ip6.h lc.h ls.h magic.h mc.h mime.h mnt.h modecanon.h modex.h \
	namval.h option.h proc.h re_comp.h recfmt.h regex.h regexp.h \
	sfio.h sfio_s.h sfio_t.h sfdisc.h shcmd.h \
	stack.h stak.h stk.h swap.h tar.h times.h tm.h tok.h \
	usage.h vdb.h vecargs.h vmalloc.h wait.h wordexp.h \
	bytesex.h endian.h fnmatch.h magicid.h fnv.h aso.h \
	$(HEADERSTD)

HEADERGEN = align.h preroot.h sig.h tmx.h tv.h \
	$(ID)_api.h $(ID)_botch.h $(ID)_ccode.h $(ID)_fcntl.h $(ID)_float.h \
	$(ID)_fs.h $(ID)_lib.h $(ID)_map.h $(ID)_mmap.h $(ID)_mode.h $(ID)_ndbm.h \
	$(ID)_param.h $(ID)_sys.h $(ID)_time.h $(ID)_time.h $(ID)_tty.h \
	$(ID)_vfork.h $(ID)_wait.h $(ID)_limits.h $(ID)_standards.h $(ID)_sizeof.h \
	$(HEADERSTD:/^/$(ID)_/)

HEADEREXP = $(ID)_common.h

HEADEROPT = fmtmsg.h libgen.h syslog.h

HEADERSTD = dirent.h iconv.h nl_types.h stdio.h wchar.h wctype.h

$(ID) 5.4 :LIBRARY: README RELEASE \
	LIBAST.3 aso.3 ast.3 astsa.3 cdt.3 chr.3 compat.3 error.3 \
	find.3 fmt.3 fmtls.3 fs3d.3 ftwalk.3 getcwd.3 hash.3 iblocks.3 \
	int.3 ip6.3 magic.3 mem.3 mime.3 modecanon.3 optget.3 path.3 \
	preroot.3 proc.3 re.3 regex.3 setenviron.3 sfdisc.3 sfio.3 \
	sig.3 spawnveg.3 stak.3 stk.3 strcopy.3 strdup.3 strelapsed.3 \
	strerror.3 stresc.3 streval.3 strgid.3 strmatch.3 stropt.3 \
	strperm.3 strsignal.3 strsort.3 strtape.3 strton.3 struid.3 \
	swap.3 tab.3 tm.3 tmx.3 tok.3 touch.3 tv.3 vecargs.3 vmalloc.3 \
	$(HEADERSRC) \
	state.c transition.c \
	dirlib.h opendir.c readdir.c rewinddir.c seekdir.c telldir.c \
	getcwd.c fastfind.c \
	hashlib.h hashalloc.c hashdump.c hashfree.c hashlast.c \
	hashlook.c hashscan.c hashsize.c hashview.c hashwalk.c \
	memhash.c memsum.c strhash.c strkey.c strsum.c \
	stracmp.c strnacmp.c \
	ccmap.c ccmapid.c ccnative.c \
	chresc.c chrtoi.c streval.c strexpr.c strmatch.c strcopy.c \
	modelib.h modei.c modex.c strmode.c \
	strlcat.c strlcpy.c strlook.c strncopy.c strsearch.c strpsearch.c \
	stresc.c stropt.c strtape.c strpcmp.c strnpcmp.c strvcmp.c strnvcmp.c \
	tok.c tokline.c tokscan.c \
	pathaccess.c pathcat.c pathcanon.c pathcheck.c pathpath.c \
	pathexists.c pathfind.c pathkey.c pathprobe.c pathrepl.c \
	pathnative.c pathposix.c pathtemp.c pathtmp.c pathstat.c \
	pathgetlink.c pathsetlink.c pathbin.c pathshell.c pathcd.c \
	pathprog.c \
	fs3d.c ftwalk.c ftwflags.c fts.c \
	astintercept.c conformance.c getenv.c setenviron.c \
	optget.c optjoin.c optesc.c optctx.c strsort.c struniq.c \
	magic.c mime.c mimetype.c signal.c sigflag.c systrace.c \
	error.c errorf.c errormsg.c errorx.c \
	localeconv.c setlocale.c translate.c \
	catopen.c iconv.c lc.c lctab.c mc.c \
	base64.c recfmt.c recstr.c reclen.c fmtrec.c \
	fmtbase.c fmtbuf.c fmtclock.c fmtdev.c fmtelapsed.c fmterror.c \
	fmtesc.c fmtfmt.c fmtfs.c fmtident.c fmtint.c fmtip4.c fmtip6.c fmtls.c \
	fmtmatch.c fmtmode.c fmtnum.c fmtperm.c fmtre.c fmttime.c fmtuid.c \
	fmtgid.c fmtsignal.c fmtscale.c fmttmx.c fmttv.c fmtversion.c \
	strelapsed.c strperm.c struid.c strgid.c \
	strtoip4.c strtoip6.c stack.c stk.c \
	swapget.c swapmem.c swapop.c swapput.c \
	sigdata.c sigcrit.c sigunblock.c \
	proclib.h procopen.c procclose.c procrun.c procfree.c \
	tmdate.c tmequiv.c tmfix.c tmfmt.c tmform.c tmgoff.c tminit.c \
	tmleap.c tmlex.c tmlocale.c tmmake.c tmpoff.c tmscan.c \
	tmsleep.c tmtime.c tmtype.c tmweek.c tmword.c tmzone.c \
	tmxdate.c tmxduration.c tmxfmt.c tmxgettime.c tmxleap.c tmxmake.c \
	tmxscan.c tmxsettime.c tmxsleep.c tmxtime.c tmxtouch.c \
	tvcmp.c tvgettime.c tvsettime.c tvsleep.c tvtouch.c \
	cmdarg.c vecargs.c vecfile.c vecfree.c vecload.c vecstring.c \
	univlib.h univdata.c touch.c mnt.c debug.c \
	memccpy.c memchr.c memcmp.c memcpy.c memdup.c memmove.c memset.c \
	mkdir.c mkfifo.c mknod.c rmdir.c remove.c rename.c link.c unlink.c \
	strdup.c strchr.c strrchr.c strstr.c \
	strtod.c strtold.c \
	strtol.c strtoll.c strtoul.c strtoull.c strton.c strtonll.c \
	strntod.c strntold.c strnton.c strntonll.c \
	strntol.c strntoll.c strntoul.c strntoull.c \
	strcasecmp.c strncasecmp.c strerror.c \
	mktemp.c tmpnam.c fsync.c \
	execlp.c execve.c execvp.c execvpe.c spawnveg.c \
	vfork.c killpg.c \
	hsearch.c tsearch.c \
	getlogin.c putenv.c setenv.c unsetenv.c \
	lstat.c statvfs.c \
	eaccess.c gross.c gross_sgi.h omitted.c \
	fakelink.h readlink.c symlink.c \
	getpgrp.c setpgid.c setsid.c waitpid.c \
	creat64.c fcntl.c open.c \
	atexit.c getdents.c getwd.c dup2.c errno.c \
	getpreroot.c ispreroot.c realopen.c setpreroot.c \
	getgroups.c mount.c system.c iblocks.c \
	modedata.c tmdata.c \
	memfatal.c sfkeyprintf.c \
	sfdcdio.c sfdcdos.c sfdcfilter.c sfdcseekable.c \
	sfdcslow.c sfdcsubstr.c sfdctee.c sfdcunion.c \
	sfdcmore.c sfdcprefix.c \
	wc.c wc2utf8.c \
	/* standards */ \
	basename.c closelog.c dirname.c fmtmsglib.c fnmatch.c ftw.c \
	getdate.c getsubopt.c glob.c nftw.c openlog.c re_comp.c \
	resolvepath.c realpath.c regcmp.c regexp.c setlogmask.c strftime.c \
	strptime.c swab.c syslog.c sysloglib.h tempnam.c \
	wordexp.c mktime.c \
	/* regex */ \
	reglib.h regalloc.c regclass.c regcoll.c regcomp.c regcache.c \
	regdecomp.c regerror.c regexec.c regfatal.c reginit.c regnexec.c \
	regsubcomp.c regsubexec.c regsub.c regrecord.c regrexec.c regstat.c \
	/* cdt */ \
	dthdr.h dtclose.c dtdisc.c dthash.c dtlist.c dtmethod.c \
	dtopen.c dtstrhash.c dttree.c dtview.c dtwalk.c \
	dtnew.c dtcomp.c \
	/* sfio */ \
	sfhdr.h sfdchdr.h \
	sfclose.c sfclrlock.c sfdisc.c sfdlen.c sfexcept.c \
	sfgetl.c sfgetu.c sfcvt.c sfecvt.c sffcvt.c \
	sfextern.c sffilbuf.c sfflsbuf.c sfprints.c sfgetd.c \
	sfgetr.c sfllen.c sfmode.c sfmove.c sfnew.c \
	sfpkrd.c sfnotify.c sfnputc.c sfopen.c sfpeek.c sfpoll.c \
	sfpool.c sfpopen.c sfprintf.c sfputd.c sfputl.c sfputr.c \
	sfputu.c sfrd.c sfread.c sfreserve.c sfscanf.c sfseek.c sfset.c \
	sfsetbuf.c sfsetfd.c sfsize.c sfsk.c sfstack.c sfstrtod.c sfsync.c \
	sfswap.c sftable.c sftell.c sftmp.c sfungetc.c sfvprintf.c \
	sfvscanf.c sfwr.c sfwrite.c sfpurge.c sfraise.c sfwalk.c \
	sfgetm.c sfmutex.c sfputm.c sfresize.c \
	_sfclrerr.c _sfeof.c _sferror.c _sffileno.c \
	_sfopen.c _sfstacked.c _sfvalue.c \
	_sfgetc.c _sfgetl.c _sfgetl2.c _sfgetu.c _sfgetu2.c \
	_sfdlen.c _sfllen.c _sfslen.c _sfulen.c \
	_sfputc.c _sfputd.c _sfputl.c _sfputm.c _sfputu.c \
	/* stdio */ \
	clearerr.c fclose.c fdopen.c feof.c ferror.c fflush.c \
	fgetc.c fgetpos.c fgets.c fileno.c fopen.c fprintf.c \
	fpurge.c fputc.c fputs.c fread.c freopen.c fscanf.c \
	fseek.c fseeko.c fsetpos.c ftell.c ftello.c fwrite.c \
	flockfile.c ftrylockfile.c funlockfile.c \
	getc.c getchar.c getw.c pclose.c popen.c printf.c \
	putc.c putchar.c puts.c putw.c rewind.c scanf.c \
	setbuf.c setbuffer.c setlinebuf.c setvbuf.c \
	snprintf.c sprintf.c sscanf.c \
	asprintf.c vasprintf.c \
	stdio/tmpfile.c ungetc.c vfprintf.c vfscanf.c vprintf.c \
	vscanf.c vsnprintf.c vsprintf.c vsscanf.c \
	_doprnt.c _doscan.c _filbuf.c _flsbuf.c _stdfun.c \
	_stdopen.c _stdprintf.c _stdscanf.c _stdsprnt.c \
	_stdvbuf.c _stdvsnprnt.c _stdvsprnt.c _stdvsscn.c \
	/* wchar stdio */ \
	fgetwc.c fwprintf.c putwchar.c vfwscanf.c wprintf.c \
	fgetws.c fwscanf.c swprintf.c vswprintf.c wscanf.c \
	fputwc.c getwc.c swscanf.c vswscanf.c \
	fputws.c getwchar.c ungetwc.c vwprintf.c \
	fwide.c putwc.c vfwprintf.c vwscanf.c \
	/* stdio extensions */ \
	stdio_c99.c fcloseall.c fmemopen.c getdelim.c getline.c \
	/* math */ \
	frexp.c frexpl.c \
	/* ast */ \
	astcopy.c astconf.c astdynamic.c astlicense.c astquery.c astwinsize.c \
	conftab.c \
	$(CC.LD.STATIC) aststatic.c getopt.c getoptl.c $(CC.LD.DYNAMIC) \
	/* aso */ \
	aso.c asolock.c asometh.c asorelax.c aso-sem.c aso-fcntl.c \
	/* vmalloc */ \
	vmalloc.h vmhdr.h vmbest.c vmclear.c vmclose.c vmdcheap.c vmdebug.c \
	vmdisc.c vmexit.c vmlast.c vmopen.c vmpool.c vmprivate.c vmprofile.c \
	vmregion.c vmsegment.c vmset.c vmstat.c vmstrdup.c vmtrace.c vmwalk.c \
	vmmopen.c malloc.c vmgetmem.c \
	/* uwin */ \
	mathimpl.h rlib.h \
	a64l.c acosh.c asinh.c atanh.c cbrt.c crypt.c erf.c \
	err.c exp.c exp__E.c expm1.c gamma.c getpass.c lgamma.c log.c log1p.c \
	log__L.c rand48.c random.c rcmd.c rint.c support.c \
	/* obsolete */ \
	sfstrtmp.c spawn.c \
	-liconv -lw /* these should be pulled in by -lc */

/*
 * man is stdio.h problematic
 * the std/stdio.h => ast_stdio.h runaround should
 * get to a steady state
 *
 * also, -D_BLD_ast must be explicit for the uwin bootstrap
 */

.MAKEINIT : .AST.INIT
.AST.INIT : .MAKE
	CCFLAGS += -D_BLD_ast

parameter	(_BLD_ast)
virtual		ast/stdio.h

		:NOPROTECT: sfprintf.c sfvprintf.c sfscanf.c sfvscanf.c

		:NOOPTIMIZE: spawnveg.c
"ibm.risc"	:NOOPTIMIZE: regcomp.c
"linux.i386-64*":NOOPTIMIZE: sfset.c
"sol?.*"	:NOOPTIMIZE: sfrd.c sfvprintf.c tmxfmt.c
"win32*"	:NOOPTIMIZE: fastfind.c mc.c
"win32*-64*"	:NOOPTIMIZE: sfvprintf.c

/*
 * NOTE: sun4 runtime link botches ro data so advertised sig_info is rw
 */

:READONLY: conftab.c lctab.c modedata.c /*sftable.c*/ \
	/*sigdata.c*/ tmdata.c univdata.c

:: atmain.C \
	stdgets.c stdprintf.c stdscanf.c stdvbuf.c stdsprnt.c \
	stdvsprnt.c stdvsnprnt.c stdvsscn.c stdopen.c \
	astsa

if "$(PWD:B)" != "cc-*"

$(INCLUDEDIR) :INSTALLPROTO: $(HEADEREXP) $(HEADERSRC) $(HEADERGEN)

:INSTALLDIR: conf

conf :: conf.sh

conflim.h conftab.h conftab.c :JOINT: conf conf.tab
	$(*:O=1:P=A) $(IFFEFLAGS:V:N=-v) $(*:O>1) $(CC) $(CCFLAGS:VP:N!=-D_BLD_*|$\(*\)) /* 2007-07-01: $(CCFLAGS:VPX:N!=-D_BLD_*) */

$(HEADERGEN) :COPY: FEATURE/$$(<:B:/$(ID)_//)

ast_namval.h :COPY: namval.h

lcgen : lcgen.c
	$(CC.NATIVE|CC) -o $(<) $(*)

lc.h lctab.c :JOINT: lcgen lc.tab
	$(*:O=1:C,^[^/],./&,) $(tmp).1 $(tmp).2 < $(*:O=2) # :P=E: in 2006
	$(PROTO) -p $(PROTOFLAGS) $(tmp).1 $(PROTOINSTALL) > $(tmp).3
	$(RM) -f $(tmp).1
	if	$(CMP) -s $(tmp).3 $(<:O=1)
	then	$(RM) $(tmp).3
	else	$(MV) $(tmp).3 $(<:O=1)
	fi
	if	$(CMP) -s $(tmp).2 $(<:O=2)
	then	$(RM) $(tmp).2
	else	$(MV) $(tmp).2 $(<:O=2)
	fi

$(LIBDIR)/file/magic :INSTALL: magic.tab

:INSTALL: $(HEADEROPT:D=$(INCLUDEDIR):B:S)

$(HEADEROPT:D=$(INCLUDEDIR):B:S) : $$(<:B:S) ast_lib.h
	case $(CC.HOSTTYPE) in
	win32.*)$(PROTO) -p $(PROTOFLAGS) $(*:O=1) $(PROTOINSTALL) > 1.$(tmp).x
		if	$(CMP) -s $(<) 1.$(tmp).x
		then	$(RM) -f 1.$(tmp).x
		else	$(MV) 1.$(tmp).x $(<)
		fi
		;;
	*)	$(SILENT) $(GREP) -l 'define[ 	][ 	]*_[hl][di][rb]_$(<:B)' $(*:O>1) > /dev/null || {
		$(PROTO) -p $(PROTOFLAGS) $(*:O=1) $(PROTOINSTALL) > 1.$(tmp).x
		if	$(CMP) -s $(<) 1.$(tmp).x
		then	$(RM) -f 1.$(tmp).x
		else	$(MV) 1.$(tmp).x $(<)
		fi
		}
		;;
	esac

/*
 * FEATURE/common for iffe probes, <ast_common.h> for ast source
 * *but* <ast_common.h> may get pulled in by intercepted headers
 * so both must be built very early
 */

$(ID)_common.h : .SCAN.IGNORE FEATURE/common
	$(SED) '/define _def_map_ast/d' < $(*) > 1.$(tmp).x
	if	$(CMP) -s $(<) 1.$(tmp).x
	then	$(RM) -f 1.$(tmp).x
	else	$(MV) 1.$(tmp).x $(<)
	fi

FEATURE/common : .SCAN.IGNORE

/*
 * more stdio.h complications ...
 * prepare for compilation by generating these headers first;
 * this helps mam by catching headers that might be indirectly
 * included on other systems
 */

.check.hdr : .IGNORE .VIRTUAL \
		FEATURE/standards - FEATURE/lib - FEATURE/common - \
		FEATURE/param - FEATURE/aso - \

=== src/lib/libcoshell/Makefile ===
/*
 * coshell library
 */

:PACKAGE: ast

CCFLAGS = $(CC.OPTIMIZE) $(CC.PIC) /* pic allows archive to be pulled into other dlls */

LICENSE = since=1990,author=gsf

coshell 1.0 :LIBRARY: RELEASE coshell.3 coshell.h colib.h \
		coopen.c coclose.c coinit.c coexec.c costash.c \
		cowait.c cokill.c cosync.c coquote.c codata.c \
		coexport.c procrun.c system.c

ignore :: ignore.sh

silent :: silent.sh

$(INCLUDEDIR) :INSTALLPROTO: coshell.h

=== src/lib/libsum/Makefile ===
:PACKAGE: ast

LICENSE = since=1996,author=gsf

CCFLAGS = $(CC.OPTIMIZE) $(CC.PIC)

sum 1.0 :LIBRARY: sum.h sumlib.c -lmd

$(INCLUDEDIR) :INSTALLPROTO: sum.h

:: RELEASE

=== debian/changelog ===
ksh (2020.0.0+really93u+20120801-9) unstable; urgency=medium

  * Updated UMEGAYA
  * Support for rootless building
  * Cleanups for debian/rules to make more use of debhelper
  * Included additional documentation file
  * Fix to skip '.' and '..' when globbing patterns like .*
  * Bumped up standards version

 -- Anuradha Weeraman <anuradha@debian.org>  Tue, 8 Dec 2020 19:27:41 -0400

ksh (2020.0.0+really93u+20120801-8) unstable; urgency=medium

  * Fix for segfault when a .paths directory exists in the PATH
  * Bug-fix on input buffer boundary of multibyte characters (Closes: #767935)
  * Added X-AppStream-Ignore=true to ksh.desktop

 -- Anuradha Weeraman <anuradha@debian.org>  Sun, 12 Jul 2020 10:09:44 -0400

ksh (2020.0.0+really93u+20120801-7) unstable; urgency=medium

  * Updated Vcs-* fields in debian/control
  * Fix AppStream warning on missing icon in .desktop file
  * Changed binfmt-support to a suggested dependency
  * Removed debian/NEWS on the ksh2020 revert (Closes: #964058)

 -- Anuradha Weeraman <anuradha@debian.org>  Mon, 29 Jun 2020 19:47:14 -0400

ksh (2020.0.0+really93u+20120801-6) unstable; urgency=high

  * v2020 of ksh is no longer being maintained and upstream repository has
    been reverted back to the last stable version of 93u+. This update
    reverts back the ksh2020 changes back to the original ksh93 from AT&T.
  * Patch for CVE-2019-14868 - certain environment variables were
    interpreted as arithmetic expressions on startup, leading to code
    injection

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 27 Jun 2020 21:17:32 -0400

ksh93 (93u+20120801-7) unstable; urgency=medium

  * Fix for crashes because job locking mechanism does not survive
    compiler optimization (Closes: #867181)
  * Fix for implicit declaration warnings
  * Updated upstream metadata

 -- Anuradha Weeraman <aweeraman@gmail.com>  Thu, 06 Feb 2020 21:21:27 -0500

ksh93 (93u+20120801-6) unstable; urgency=high

  * Team upload.
  * Fix a few missing CFLAGS, CPPFLAGS, LDFLAGS

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 04 Feb 2020 21:36:56 +0100

ksh93 (93u+20120801-5) unstable; urgency=high

  * Team upload.
  * Fix ksh93 name in more places; improve ksh2020 coïnstallability
  * Bump Policy (no change)
  * Fix doc-base section
  * Drop unused french manpage
  * Update packaging (debhelper, etc.)
  * Add UMEGAYA file
  * Switch to update-alternatives for binfmt-misc registration
  * Refresh patches, add missing comments
  * R³: actually, yes (upstream portion of installation)
  * Update lintian overrides
  * Add debian/NEWS, documenting why this package was split
  * Ensure coïnstallability: versioned Breaks: ksh

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 27 Jan 2020 16:49:22 +0100

ksh93 (93u+20120801-4) unstable; urgency=medium

  * Re-introduce ksh93 into the archive as a separate package (Closes: #948745)
  * Bumped up standards-version
  * Set the hardened build flags
  * Use alternatives system for binaries

  [ Boyuan Yang ]
  * debian/control: Explicitly specify Vcs-Git branch.

 -- Anuradha Weeraman <aweeraman@gmail.com>  Sat, 18 Jan 2020 21:34:10 -0500

=== debian/control ===
Source: ksh
Section: shells
Priority: optional
Maintainer: Anuradha Weeraman <anuradha@debian.org>
Homepage: http://www.kornshell.com/
Build-Depends: debhelper-compat (= 12), dh-exec
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/ksh.git
Vcs-Browser: https://salsa.debian.org/debian/ksh

Package: ksh
Architecture: any
Conflicts: ksh93
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: binfmt-support
Description: Real, AT&T version of the Korn shell
 Ksh is a UNIX command interpreter (shell) that is intended for both
 interactive and shell script use. Its command language is a superset of
 the sh(1) shell language.
 .
 The 1993 version adds a number of new, mostly scripting related,
 features over the 1988 version that is typically distributed with
 commercial UNIX variants. For example, it has lexical scoping, compound
 variables, associative arrays, named references and floating point
 math.
 .
 The shcomp tool can be used to compile ksh scripts into a binary format.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+fixfilepath
export DPKG_EXPORT_BUILDFLAGS=1
export LC_ALL=C
export LANG=C
export TZ=GMT

include /usr/share/dpkg/buildflags.mk

export CCFLAGS+=$(shell dpkg-buildflags --get CFLAGS)
export CCFLAGS+=$(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS+=$(shell dpkg-buildflags --get LDFLAGS)

ARCH = $(shell bin/package)

%:
	dh $@

override_dh_auto_configure:
	@echo "CCFLAGS=$(CCFLAGS)"
	@echo "LDFLAGS=$(LDFLAGS)"

override_dh_auto_build:
	bin/package make strip=0

override_dh_auto_install:
	cp arch/$(ARCH)/bin/ksh debian/ksh/bin/ksh93
	cp arch/$(ARCH)/bin/shcomp debian/ksh/usr/bin/shcomp93
	cp arch/$(ARCH)/man/man1/sh.1 debian/ksh/usr/share/man/man1/ksh93.1
	cp arch/$(ARCH)/fun/* debian/ksh/usr/share/ksh/functions

override_dh_installchangelogs:
	dh_installchangelogs src/cmd/ksh93/RELEASE

clean:
	dh_testdir
	dh_clean
	for i in ignore silent package mamprobe ; do \
		sed -i -e '/^#.\{70\}#/ d'  bin/$$i ; \
	done
	rm -rf arch bin/*.old
